#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Ratebereich */
const int range = 100;
/* Anzahl Rateversuche */
const int tries = 6;

int rnd(int range);
void seedrnd(void);

int main()
{
   int guessme, guess, t;
   const int eingabelaenge = 10;
   char eingabe[eingabelaenge];

   seedrnd(); /* Startwert fr Zufallsgenerator */
   guessme = rnd(range); /* diese Zahl erraten */

   printf("RATE!?!\nRate die Zufallszahl.\n");
   printf("Ich denke an eine Zahl zwischen 1 und %i. \n", range);
   printf("Du hast %i Versuche.\n", tries);

   /* geben wir also tries Versuche */
   for(t = 1; t <= tries; t++)
   {
      printf("Versuch #%i: ", t);
      // Rateversuch holen
      fgets(eingabe, eingabelaenge, stdin);
      guess = atoi(eingabe);

      if (guess == guessme) /* richtig */
      {
         printf("Du hast es erraten!\n");
         break;
      }
      else if (guess<guessme)
         printf("Zu niedrig!\n");
      else
         printf("Zu hoch!\n");
   }

   printf("Die Zahl war %i.\n", guessme);

   return 0;
}

/*
Zufallszahlengenerator-Funktion
liefert eine Zufallszahl zwischen 1 und upper
*/

int rnd(int upper)
{
   int r;

   r = rand()%upper + 1;
   return(r);
}

/*
Setzt Startwert fuer Zufallszahlen
*/

void seedrnd(void)
{
   srand((unsigned)time(NULL));
}
