#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define TEXTLAENGE 20

void clearInput(void);
void addNewAccount(void);

struct account
{
   int number;
   char lastname[TEXTLAENGE + 1];
   char firstname[TEXTLAENGE + 1];
   float balance;
   struct account* next;
};

struct account* firsta;
int anum = 0;

int main()
{
   char ch;
   firsta = NULL;

   do
   {
      puts("\nN - Neues Konto");
      puts("E - Ende\n");
      printf("\tIhre Wahl: ");
      ch = getchar();
      ch = toupper(ch);
      clearInput();

      switch(ch)
      {
         case 'N':
            puts("Ein neues Konto anlegen\n");
            addNewAccount();
            break;
         case 'E':
            puts("Programmende\n");
            default:
            break;
      }


   }
   while(ch != 'E');

   return 0;
}

void clearInput(void)
{
    while ((getchar()) != '\n');
}

char* entferneNL(char* string)
{
   char* string2 = string;
   while (*string2)
   {
      if (*string2 == '\n')
         *string2 = '\0';
      string2++;
   }

   return string;
}

void addNewAccount(void)
{
   struct account* currenta;
   struct account* newa;

   char amount[TEXTLAENGE+1];

   newa = malloc(sizeof(struct account));

/*
 * Ist das der erste Datensatz?
 * Falls ja, dann alle Zeiger darauf einrichten
 */

   if (firsta==NULL)
      firsta = currenta = newa;

/*
 * Andernfalls das Ende der Liste finden
 * und die neue Struktur am Ende einfuegen
 */
   else
   {
      currenta = firsta;

      while (currenta->next != NULL)
         currenta = currenta->next;
      /* der letzte Datensatz wurde gefunden */
      currenta->next = newa;  /* die Adresse des neuen speichern */
      currenta = newa;
   }

/* Jetzt die Struktur fuellen */
    anum++;
    printf("%27s: %5i\n", "Kontonummer", anum);
    currenta->number = anum;

    printf("%27s: ", "Nachname des Kunden");
    fgets(currenta->lastname, TEXTLAENGE, stdin);
    entferneNL(currenta->lastname);

    printf("%27s: ", "Vorname des Kunden");
    fgets(currenta->firstname, TEXTLAENGE, stdin);
    entferneNL(currenta->firstname);

    printf("%27s: EUR ", "Kontostand");
    fgets(amount, TEXTLAENGE, stdin);
    currenta->balance = atof(amount);

/*
 * der neue Datensatz ist das letzte Element
 * der Liste, also auch kennzeichnen
 */

   currenta->next = NULL;
}

